package com.zskk.service;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import com.jfinal.plugin.activerecord.ActiveRecordPlugin;
import com.jfinal.plugin.druid.DruidPlugin;
import com.jfinal.weixin.sdk.api.ApiResult;
import com.jfinal.weixin.sdk.api.SnsAccessToken;
import com.jfinal.weixin.sdk.api.SnsAccessTokenApi;
import com.jfinal.weixin.sdk.api.SnsApi;
import com.zskk.model.Report;
import com.zskk.model.User;
import com.zskk.model._MappingKit;

public class WeixinService {
	
	/**
	 * 用户同意授权，获取带code的url
	 * @return
	 * @throws UnsupportedEncodingException 
	 */
	public String getCodeUrl(String appId, String redirect_uri) throws UnsupportedEncodingException {
		String encode = URLEncoder.encode(redirect_uri, "UTF-8");
		String url = SnsAccessTokenApi.getAuthorizeURL(appId, encode, false);
		return url;
	}

	/**
	 * 通过回调地址参数code获取access_token
	 * @param appId
	 * @param secret
	 * @param code
	 * @return
	 */
	public SnsAccessToken getWebAccessToken(String appId, String secret, String code) {
		SnsAccessToken snsAccessToken = SnsAccessTokenApi.getSnsAccessToken(appId, secret, code);
		return snsAccessToken;
	}
	
	/**
	 * 拉取用户信息
	 * @param accessToken
	 * @param openId
	 * @return
	 */
	public ApiResult getWebWeixinUserInfo(String accessToken, String openId) {
		ApiResult apiResult = SnsApi.getUserInfo(accessToken, openId);
		User user = User.dao.findFirst("select * from user where wx_openid=?",openId);
		user.setWxIcon(apiResult.getStr("headimgurl"));
		user.setWxNickname(apiResult.getStr("nickname"));
		user.update();
		return apiResult;
	}
	
	public static void main(String[] args) {
//			DruidPlugin druidPlugin = new DruidPlugin("jdbc:mysql://www.pacsonline.cn:3306/pacsonline?useSSL=false", "pacs",
//					"ZSKK@2017~!@#".trim());
//			druidPlugin.start();
//			ActiveRecordPlugin arp = new ActiveRecordPlugin(druidPlugin);
//
//			_MappingKit.mapping(arp);
//			arp.start();
//
//			Report report = Report.dao.findById("9c11936e4a8440d6");
//			System.out.println(report);
		
		
	}
}
